import jDisco.*;
import jDisco.Process;

/*
 * Simulation of a simple ecosystem.
 *
 * A system of laydy-birds and green-flies is simulated for 100 time units.
 */

public class SimpleEcosystem extends Process {
    Variable ladybirds;
    Variable greenflies;
    
     public void actions() {
         ladybirds  = new Variable(1000).start();
         greenflies = new Variable(100000).start();
         start();
         hold(100);
         System.out.println(ladybirds.state);
         System.out.println(greenflies.state);
    }
    
    public void derivatives() { 
        ladybirds.rate  = (-0.3 + 3.0e-7 * greenflies.state) * ladybirds.state; 
        greenflies.rate = ( 0.3 - 3.0e-4 * ladybirds.state)  * greenflies.state; 
    }
        
    public static void main(String[] args) {
        activate(new SimpleEcosystem());
    }
}
